/**
 * Computación Paralela
 * Funciones para las prácticas - Funciones extra para tablón
 * 
 * @author Javier Fresno
 * @author Arturo Gonzalez-Escribano 
 * @version 1.3 (curso 1415)
 * @version 1.4 (curso 1516)
 * @version 1.5 (curso 1617)
 *
 */
#ifndef _CPUTILS_TABLON_
#define _CPUTILS_TABLON_

#warning "Using cputilstablon.h"

#define CP_SECURE_FOPEN_PATH "/home/tablon/inputs1617/"
#define CP_SECURE_FOPEN_SIZE 1024

#include <string.h>

/**
 * safe fopen
 */
inline FILE * cp_abrir_fichero(const char *path){

	// 1. If the path has a delimiter, it is not valid
	int i;
	for (i = 0; i < strlen(path); i++){
		if (path[i] == '/') return NULL;
		// Do not allow to access parent/ancestor directories
		if ( i>0 && path[i] == '.' && path[i-1] == '.' ) return NULL;
	}

	// 2. Compose the path
	if((strlen(CP_SECURE_FOPEN_PATH) + strlen(path)) > CP_SECURE_FOPEN_SIZE )
		return NULL;

	// Array to keep the path
	char fullpath[CP_SECURE_FOPEN_SIZE];
	fullpath[0] = 0;

	strcat(fullpath, CP_SECURE_FOPEN_PATH);
	strcat(fullpath, path);

	// 3. Open the file
	return fopen(fullpath,"r");

}

#ifdef CP_OPENMP

#include <omp.h>
#include <stdio.h>
#include <stdlib.h>


int cp_omp_num_threads = -1;

void cp_omp_set_num_threads(int num_threads){

	if(cp_omp_num_threads == -1)
		cp_omp_num_threads = omp_get_max_threads();

	if(num_threads > cp_omp_num_threads){
		printf("Tablon: max threads is %d\n",cp_omp_num_threads);
	} else {
		omp_set_num_threads(num_threads);
	}
}
#define omp_set_num_threads(nt) cp_omp_set_num_threads(nt)

#endif

#endif
