#!/usr/bin/python
# -*- coding: utf-8 -*- 

################################################################################
#
# Servidor Tablon - Reiniciador
# Asignatura Computación paralela
# Javier Fresno, 2016
#
################################################################################


import subprocess
import time
import signal
import sys
import os
import urllib2
import json


# Time to restart (in seconds)
RESTARTTIME = 60 * 60
SLEEPTIME = 10

# The command
cmd = ['python','server.py',str(RESTARTTIME)]



# Function to check if the server has changed
# It is used to restart the server if changes
# have been done
last_time = None
def has_server_changed():
	global last_time
	newtime = os.stat('server.py').st_mtime
	if last_time != newtime:
		last_time = newtime
		return True
	return False
# Init
has_server_changed()

#
# Not using this now
#
def is_server_ok():
	return True
	try:
		response = urllib2.urlopen('http://localhost:8080/ok')
		data = json.loads(response.read())
		return data.isok
	except:
		pass
	return False


#
# Global flag to exit the reiniciador
#
sigint = False

# Signal callback
def quit_gracefully(*args):
	global sigint
	sigint = True
signal.signal(signal.SIGINT, quit_gracefully)




#
# Infinite loop to run
#
while True:

	# Wait for Control+C
	try:

		# Start the server
		print "Reiniciador: START"
		process = subprocess.Popen(cmd)

		# Not running flat
		not_running = 0


		# Sleep
		start = time.time()
		while time.time() - start < RESTARTTIME:

			# Sleep before checking other things
			time.sleep(SLEEPTIME)

			# Check if the server has changed
			if has_server_changed():
				print "Reiniciador: SERVER HAS CHANGED"
				break

			# Check if the server is running
			if process.poll() != None:
				not_running += 1
			else:
				not_running = 0

			# If the server is not running after 3 checks: restart
			if not_running == 3:
				print "Reiniciador: SERVER IS NOT RUNNING"
				break

			# Check if server is ok: not using 
			if not is_server_ok():
				print "Reiniciador: SOMETHING WRONG WITH SERVER"
				break

			
			if sigint:
				raise "Reiniciador: received SIGINT"


		# Signal the server to shutdown
		print "Reiniciador: send SIGINT"
		try:
			process.send_signal(signal.SIGINT)
		except:
			pass

		# Wait a bit to let the server close normally
		times = 10
		while process.poll() == None:
			time.sleep(2)
			times -= 1
			if times < 0:
				break

		# Kill the server
		if process.poll() == None:
			print "Reiniciador: send KILL"
			try:
				process.terminate()
				time.sleep(1)
				process.kill()
			except:
				pass

		# End of loop
		time.sleep(5)

		print "Reiniciador: END LOOP"


	# Exception: probably Control + C
	except Exception as e:
		try:
			process.kill()
		except:
			pass
		sys.exit(-1)








