// Librerías estándar.
#include <stdio.h>
#include <stdlib.h>

// Fichero de cabecera de MPI.
#include <mpi.h>
// Fichero de cabecera OpenMP
#include <omp.h>


/**
 * Función main.
 */
int main(int argc, char *argv[]){


	int rank,tid;

	// Inicialización del entorno MPI.
	MPI_Init(&argc, &argv);

	// Obtenemos el identificador y el número de procesos.
	MPI_Comm_rank(MPI_COMM_WORLD, &rank);

	// 	Nombre del procesador
	char name[MPI_MAX_PROCESSOR_NAME];
	int name_size;
	MPI_Get_processor_name(name,&name_size);

	/* Fork a team of threads giving them their own copies of variables */
	#pragma omp parallel private(tid)
	 {

		 /* Obtain thread number */
		 tid = omp_get_thread_num();
		 printf("Hello World from %s, proc %d, thread %d\n", name, rank, tid);

	 } /* All threads join master thread and disband */




	// Finalización en entorno MPI.
	MPI_Finalize();

	// Valor devuelto por el programa.
	return EXIT_SUCCESS;
}
